<?php
class UserGateway {
    private $connection;

    public function __construct(Connection $connection) {
        $this->connection = $connection;
    }

    public function getAthlete() {
        $query = "SELECT * FROM Athlete";
        return $this->connection->executeWithErrorHandling($query);
    }

    public function getCoach() {
        $query = "SELECT * FROM Coach";
        return $this->connection->executeWithErrorHandling($query);
    }

    public function getAthleteById($userId) {
        $query = "SELECT * FROM Athlete WHERE idAthlete = :id";
        $params = [':id' => [$userId, PDO::PARAM_INT]];
        return $this->connection->executeWithErrorHandling($query, $params);
    }

    public function getCoachById($userId) {
        $query = "SELECT * FROM Coach WHERE idCoach = :id";
        $params = [':id' => [$userId, PDO::PARAM_INT]];
        return $this->connection->executeWithErrorHandling($query, $params);
    }

}

// Exemple d'utilisation
//$dsn = "pgsql:host=localhost;port=5432;dbname=mydatabase;user=myuser;password=mypassword";
//$connection = new Connection($dsn);
//$gateway = new UserGateway($connection);

//$allAth = $gateway->getAthlete();
//print_r($allAth);

//$allCoach = $gateway->getCoach();
//print_r($allCoach);

//$singleAth = $gateway->getAthleteById(1);
//print_r($singleAth);

//$singleCoach = $gateway->getCoachById(1);
//print_r($singleCoach);

?>
